# This file is managed by CHEF (project cookbook).

# Global default settings:
global:
  scrape_interval: <%= node['prometheus']['scrape_interval'] %>
  evaluation_interval: <%= node['prometheus']['evaluation_interval'] %>
  external_labels:
    monitor: '<%= (node['project']['project'].map {|project| node[project]['domain']}).join(",") %>'
    # use status to set downtimes manually editing [online,offline]
    status: 'online'

scrape_configs:
- job_name: "prometheus"
  metrics_path: "/metrics"
  static_configs:
    - targets: ["127.0.0.1:9090"]
- job_name: "node_exporter"
  metrics_path: "/metrics"
  static_configs:
    - targets: ["127.0.0.1:<%= node['prometheus']['node_exporter']['port'] %>"]
- job_name: "blackbox_exporter"
  metrics_path: "/probe"
  params:
    module: [http_2xx]
  static_configs:
    - targets:
      <% node['project']['project'].each do |project| %>
      - <%= node[project]['domain_www_prefix'] ? "www.#{node[project]['domain']}" : node[project]['domain'] %>
      <% end %>
  relabel_configs:
    - source_labels: [__address__]
      target_label: __param_target
    - source_labels: [__param_target]
      target_label: instance
    - target_label: __address__
      replacement: 127.0.0.1:<%= node['prometheus']['blackbox_exporter']['port'] %>
- job_name: "pushgateway"
  metrics_path: "/metrics"
  honor_labels: true
  static_configs:
    - targets: ["127.0.0.1:<%= node['prometheus']['pushgateway']['port'] %>"]
- job_name: "netdata"
  metrics_path: '/api/v1/allmetrics'
  params:
    format: [prometheus]
  static_configs:
    - targets: ["127.0.0.1:19999"]
- job_name: "status"
  scrape_interval: 5s
  scrape_timeout: 2s
  metrics_path: "/status.php"
  honor_labels: true
  scheme: <%= node['nginx']['ssl']['enabled'] ? 'https' : 'http' %>
  static_configs:
    - targets:
      <% node['project']['project'].each do |project| %>
      - <%= node[project]['domain_www_prefix'] ? "www.#{node[project]['domain']}" : node[project]['domain'] %>
      <% end %>
# DNS checks
<% node['project']['project'].each do |project| %>
<% domains = [] %>
<% domains.push(node[project]['domain']) %>
<% domains.push("www.#{node[project]['domain']}") if node[project]['domain_www_prefix'] %>
<% domains.each do |domain| %>
- job_name: <%= domain %>
  metrics_path: /probe
  params:
    module: [<%= domain %>]
  static_configs:
    - targets:
      <% node[project]['nameservers'].each do |ns| %>
      - <%= ns %>:53
      <% end %>
  relabel_configs:
    - source_labels: [__address__]
      target_label: __param_target
    - source_labels: [__param_target]
      target_label: instance
    - target_label: __address__
      replacement: 127.0.0.1:<%= node['prometheus']['blackbox_exporter']['port'] %>
<% end %>
<% end %>
